#ifndef LLADT_H
#define LLADT_H
#include<iostream>
#include<assert.h>

using namespace std;

// node in linked list
template<class Type>
struct MyNode {
   Type data;
   MyNode <Type> *next;
};


// linked list class
template<class Type>
class MyList {

protected:
   MyNode<Type> *head;        // always points to beginning of list

public:
   MyList();                  // implied "create" function
   ~MyList();                 // implied "delete" function
   bool IsEmpty() const;      // check if list is empty
   Type FrontOfList() const;  // return first item
   void Traverse () const;    // traverse list
   void RecTraverse () const; // driver function for recursive traverse
   void Insert (Type);        // insert into list in sorted order
   void Delete (Type);        // delete from list

private:
   void RecTraverse2(MyNode<Type>*) const; // recursive traverse
};                            // const: used when class members are not changed
#endif